Целью данного проекта была разработка сервиса для показа баннеров пользователю. Сервис должен быть масштабируемым, производительным и легко интегрируемым в существующую инфраструктуру.

## Анализ требований
1. Перед началом разработки были проанализированы основные требования к сервису:
2. Возможность показа баннеров пользователю на основе его характеристик (например, возраст, пол, интересы). 
3. Поддержка различных типов баннеров (статичные, анимированные, видео). 
4. Учет статистики показов и кликов для каждого баннера. 
5. Возможность управления баннерами через административную панель (добавление, редактирование, удаление). 
6. Высокая производительность и низкая задержка при показе баннеров. 
7. Масштабируемость для обработки большого количества запросов. 
8. Безопасность данных и защита от злоупотреблений.

## Разработка

### API для показа баннеров:
1. Реализован эндпоинт /api/banners, который принимает данные пользователя и возвращает наиболее релевантный баннер. 
2. Логика выбора баннера основана на алгоритме машинного обучения (рекомендательная система).

### API для управления баннерами:
1. Эндпоинты для CRUD операций с баннерами (/api/banners/create, /api/banners/update, /api/banners/delete). 
2. Валидация данных и проверка прав доступа.

### Статистика:
1. Реализован сбор статистики показов и кликов. 
2. Данные хранятся в отдельной таблице базы данных и доступны для анализа через API.